package pathgame.rendering;

import java.util.Map;
import me.hammerle.snuviengine.api.Renderer;
import pathgame.gameplay.Player;
import pathgame.gameplay.lastPlayerSteps;
import pathgame.tilemap.TileMap;

public class HUDRenderer
{

    private lastPlayerSteps lastSteps = new lastPlayerSteps();

    public void renderTick(Renderer r, Player p, float lag)//TileMap map, TileMapRenderer map, float lag, float offX, float offY)
    {

        String objectiveTracker = String.valueOf(p.getObjectivesVisited()) + "/" + String.valueOf(p.getObjectivesAmount()) + " Towns";
        String energy = String.valueOf(p.getEnergyLeft()) + "/" + String.valueOf(p.getEnergySupply()) + " Energy used";
        String minusEnergy = "";

        //int mEnergy = p.getMinusEnergy();
//        if(mEnergy>0)
//        {
//            minusEnergy = "-" + String.valueOf(mEnergy);
//        }
        renderHUDBackgound(r);

        r.setMixColorEnabled(false);
        r.setColorEnabled(true);
        r.setTextureEnabled(true);

        //render ObjectiveTracker
        r.translateTo(0.0f, 0.0f);
        r.scale(2.0f, 2.0f);
        r.updateMatrix();
        r.getFontRenderer().drawString(2, 1, objectiveTracker);

        //render energy
        r.getFontRenderer().drawString(
                r.getViewWidth() * 0.5f
                - r.getFontRenderer().getSize(energy).getWidth(),
                1, energy);

        //render minus Energy
        for(int i = 0; i < p.getLastSteps().getLastPlayerSteps().size(); ++i)
        {
            minusEnergy = "-" + String.valueOf(p.getLastSteps().getLastPlayerSteps().get(i).getMinusValue());
            //r.getFontRenderer().drawString(p.getLastSteps().getLastPlayerSteps().get(i).getX()*32, p.getLastSteps().getLastPlayerSteps().get(i).getY()*32, minusEnergy);
            r.getFontRenderer().drawString(r.getViewWidth() * 0.5f - 144, 3 + (p.getLastSteps().getLastPlayerSteps().get(i).getDiffY() * 32), minusEnergy);
            p.getLastSteps().getLastPlayerSteps().get(i).updateMinusValues(lag);
        }

    }

    void renderHUDBackgound(Renderer r)
    {
        r.setMixColorEnabled(true);
        r.setColorEnabled(true);
        r.setTextureEnabled(false);
        r.setBlendingEnabled(true);

        r.getColorRenderer().drawRectangle(0, 0, r.getViewWidth(), 20, 0x33_00_00_00);//ABGR
    }

}
